<?php $token = $_GET['t']; ?>
<!DOCTYPE html>
<html lang="en">

<head>
  <title>1Redirection</title>
  <!-- no crawling -->
  <meta name="robots" content="none" />

  <meta charset="utf-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no" />
  <link rel="shortcut icon" href="./images/logo.png" type="image/x-icon">
  <!-- <link rel="stylesheet" href="//cdn.materialdesignicons.com/5.4.55/css/materialdesignicons.min.css">
  <link href="https://cdn.jsdelivr.net/npm/vuetify@2.2.4/dist/vuetify.min.css" rel="stylesheet">
  <script src="https://cdn.jsdelivr.net/npm/vue@2.x/dist/vue.js"></script> -->
  <link href="https://cdnjs.cloudflare.com/ajax/libs/MaterialDesign-Webfont/5.4.55/css/materialdesignicons.min.css" rel="stylesheet">
  <link href="https://cdnjs.cloudflare.com/ajax/libs/vuetify/2.2.4/vuetify.min.css" rel="stylesheet">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/vue/2.7.16/vue.min.js"></script>
  <script src="https://unpkg.com/sweetalert/dist/sweetalert.min.js"></script>
  <script src="https://code.jquery.com/jquery-3.3.1.min.js" integrity="sha256-FgpCb/KJQlLNfOu91ta32o/NMZxltwRo8QtmkMRdAu8=" crossorigin="anonymous"></script>

  <!-- polyfill (IE only) -->
  <script src="https://cdnjs.cloudflare.com/ajax/libs/babel-core/5.6.15/browser-polyfill.min.js"></script>
  <!-- End polyfill (IE only) -->
  <style>
    [v-cloak] {
      display: none;
    }

    #app {
      background-color: white;
      background-image: linear-gradient(to bottom, #4fa2c1, #74ca9e);
      background-position: 50% 0%;
      width: 100vw;
      min-height: 100vh;
    }

    .helf {
      height: 50%;
    }

    .full {
      height: 100%;
    }

    .align-middle {
      vertical-align: middle;
    }

    .v-icon.icon-rotate {
      transform: rotateZ(-180deg);
    }

    .swal-modal {
      font-family: 'Verdana', 'Geneva', sans-serif !important;
    }

    td {
      max-width: 20vw;
    }

    .v-application--is-ltr .v-data-table__mobile-row__cell {
      max-width: 50vw;
    }

    .auto-width {
      width: auto;
    }
  </style>
</head>

<body>
  <div v-cloak class="cloak">
    <div class="subheading">抱歉！你的瀏覽器已停用了JavaScript功能，請啟用JavaScript後重新整理頁面。</div>
  </div>
  <div id="app">
    <v-app>
      <v-content>
        <v-container class="px-0" fluid fill-height v-cloak>
          <v-dialog v-model="form.shown" scrollable max-width="1200px">
            <v-card>
              <v-card-title class="primary pa-0">
                <v-row no-gutters align="center" class="py-2 px-3 white--text">
                  <v-col>
                    <h4 class="title">
                      <span class="align-middle">Redirection</span>
                    </h4>
                  </v-col>
                  <v-col cols="auto">
                    <v-btn class="ma-0" icon color="white" @click="form.shown = false">
                      <v-icon>mdi-close</v-icon>
                    </v-btn>
                  </v-col>
                </v-row>
              </v-card-title>
              <v-card-text class="py-2 px-3" v-if="form.data">
                <v-form v-model="form.valid" ref="form" lazy-validation>
                  <v-row dense>
                    <v-col cols="12">
                      <div class="caption">Type</div>
                      <v-radio-group v-model="form.data.type" :rules="[v => !!v || 'Type is required']" required hide-details="auto" validate-on-blur class="ma-0" row @change="(form.data.type!='redirect')?(form.data.is_canonical = false):''">
                        <v-row dense>
                          <v-col>
                            <v-radio :color="generateColorRGB('redirect')" label="redirect" value="redirect"></v-radio>
                          </v-col>
                          <v-col>
                            <v-radio :color="generateColorRGB('iframe')" label="iframe" value="iframe"></v-radio>
                          </v-col>
                          <v-col>
                            <v-radio :color="generateColorRGB('eatcrazy')" label="Eatcrazy" value="eatcrazy"></v-radio>
                          </v-col>
                        </v-row>
                      </v-radio-group>
                    </v-col>
                    <v-col cols="12" md="6">
                      <v-text-field v-model="form.data.name" :rules="
                          [
                            v => !!v || 'Route name is required', 
                            v => (v+'').length<=180 || 'UTM campaign source may contain at most 180 characters'
                          ]" label="Route name" required hide-details="auto" validate-on-blur>
                        <template v-slot:prepend>
                          <v-menu :close-on-content-click="false" offset-x transition="slide-y-transition">
                            <template v-slot:activator="{on}">
                              <v-btn x-small icon v-on="on" @click="">
                                <v-chip x-small class="px-1" style="height:8px;" :color="form.data.is_active?'success':'grey lighten-2'" @click=""></v-chip>
                              </v-btn>
                            </template>
                            <v-list dense nav>
                              <v-list-item color="primary" :input-value="form.data.is_active" style="min-height:32px" @click="form.data.is_active=true">
                                <v-chip x-small class="px-1 mr-2" style="height:8px;" color="success"></v-chip>
                                <v-list-item-title :class="{'font-weight-bold':form.data.is_active, 'grey--text': !form.data.is_active}">Active</v-list-item-title>
                              </v-list-item>
                              <v-list-item color="primary" :input-value="!form.data.is_active" style="min-height:32px" @click="form.data.is_active=false">
                                <v-chip x-small class="px-1 mr-2" style="height:8px;" color="grey lighten-2"></v-chip>
                                <v-list-item-title :class="{'font-weight-bold':!form.data.is_active, 'grey--text': form.data.is_active}" color="grey lighten-2">Inactive</v-list-item-title>
                              </v-list-item>
                            </v-list>
                          </v-menu>
                        </template>
                      </v-text-field>
                    </v-col>
                    <v-col cols="12" md="6">
                      <v-combobox :items="tags" label="Tags" ref="tags" v-model="form.data.tags" hide-details small-chips multiple deletable-chips>
                        <template v-slot:selection="data">
                          <v-chip :dark="getColorLuminance(generateColorRGB(data.item))<128" :color="generateColorRGB(data.item)" label small class="px-1" :key="JSON.stringify(data.item)" v-bind="data.attrs" :input-value="data.selected" :disabled="data.disabled" @click:close="data.parent.selectItem(data.item)">
                            {{ data.item }}
                          </v-chip>
                        </template>
                      </v-combobox>
                    </v-col>
                    <v-col cols="12">
                      <v-text-field v-model="form.data.destination" :rules="form.data.type=='iframe'?[
                            v => !!v || 'Destination is required',
                            v => /^(https):\/\//.test(v) || 'Iframe destination may only start with https://',
                            v => is_valid_url(v) || v + ' is not a valid url',
                          ]:[
                            v => !!v || 'Destination is required',
                            v => is_valid_url(v) || v + ' is not a valid url',
                          ]" label="Destination" required hide-details="auto" validate-on-blur></v-text-field>
                    </v-col>
                    <v-col cols="12" md="4">
                      <v-select :items="domains.filter(d=>form.data.type=='eatcrazy'?(d=='booking2.eatcrazy.app'||d=='booking.eatcrazy.app'):true)" v-model="form.data.domain" :rules="[v => !!v || 'Domain is required']" label="Domain" required hide-details="auto" validate-on-blur></v-select>
                    </v-col>
                    <v-col cols="12" md="8">
                      <v-text-field v-model="form.data.path" :rules="[
                            v => !!v || 'Path is required',
                            v => !/^\//.test(v) || 'Path may not start with /',
                            v => /[a-zA-Z]/.test(v) || 'Path may contain aleast one alphabetic character',
                            v => /^[a-zA-Z0-9\-\_\/]+$/.test(v) || 'Path may only contain alphanumeric, (_), (-) and (/)',
                            v => (v+'').length>=3 || 'Path may contain at least 3 characters',
                            v => (v+'').length<=180 || 'UTM campaign source may contain at most 180 characters'
                          ]" label="Path" required hide-details="auto" @blur="form.data.path = form.data.path?form.data.path.replace(/\/+/g,'\/'):form.data.path" validate-on-blur></v-text-field>
                    </v-col>
                    <!-- wechat redirect -->
                    <v-col cols="12">
                      <v-checkbox v-model="form.data.is_open_in_browser" label="Open in browser (WeChat)" :true-value="true" :false-value="false" color="primary" class="mt-0 mx-4" hide-details></v-checkbox>
                    </v-col>
                    <!-- seo preview -->
                    <v-col cols="12">
                      <v-card flat :outlined="!form.data.is_canonical">
                        <v-card-text class="py-2">
                          <v-row dense>
                            <v-col>
                              <v-checkbox v-model="form.data.is_canonical" label="Override destination preview" :true-value="false" :false-value="true" color="primary" class="mt-0" :disabled="form.data.type!='redirect'" hide-details></v-checkbox>
                            </v-col>
                            <v-col cols="auto" v-if="!form.data.is_canonical && _get(form,'data.destination','')!=''">
                              Get Preview
                              <v-btn small color="primary" icon :loading="gettingPreview" @click="getPreview">
                                <v-icon small>mdi-file-search-outline</v-icon>
                              </v-btn>
                            </v-col>
                          </v-row>
                        </v-card-text>
                        <v-expand-transition>
                          <v-card-text class="py-0" v-if="!form.data.is_canonical">
                            <v-row dense>
                              <v-col cols="12">
                                <v-text-field v-model="form.data.meta.title" label="Preview title" :loading="gettingPreview" hide-details></v-text-field>
                              </v-col>
                              <v-col cols="12">
                                <v-text-field v-model="form.data.meta.description" label="Preview description" :loading="gettingPreview" hide-details></v-text-field>
                              </v-col>
                              <v-col cols="12">
                                <input type="file" accept="image/*" @change="processFile($event,'target.files.0')" id="upload_image" ref="img_file" hidden>
                                <v-text-field v-model="form.data.meta.image" label="Preview image" :append-icon="form.data.meta.image?'mdi-image-edit':'mdi-image-plus'" @click:append="$refs.img_file.click()" :loading="uploading_image || gettingPreview" hide-details>
                                  <template v-slot:prepend-inner>
                                    <div>
                                      <v-card flat v-if="form.data.meta.image" :href="form.data.meta.image" target="_blank">
                                        <v-avatar size="24" tile>
                                          <img :src="form.data.meta.image" alt="Preview image">
                                        </v-avatar>
                                      </v-card>
                                      <v-icon v-else color="primary" @click="$refs.img_file.click()">mdi-image</v-icon>
                                    </div>
                                  </template>
                                </v-text-field>
                              </v-col>
                            </v-row>
                          </v-card-text>
                        </v-expand-transition>
                      </v-card>
                    </v-col>
                    <!-- utm campaign -->
                    <v-col cols="12">
                      <v-card flat :outlined="form.data.is_enable_utm">
                        <v-card-text class="py-2">
                          <v-checkbox v-model="form.data.is_enable_utm" :true-value="true" :false-value="false" label="Enable UTM Campaign features (Optional)" color="primary" class="mt-0" hide-details></v-checkbox>
                        </v-card-text>
                        <v-expand-transition>
                          <v-card-text class="py-0" v-if="form.data.is_enable_utm">
                            <v-row dense>
                              <v-col cols="12" sm="6" md="4">
                                <v-text-field :rules="[
                                      v => (v+'').length<=180 || 'UTM campaign source may contain at most 180 characters'
                                    ]" validate-on-blur v-model="form.data.utm.utm_source" label="UTM campaign source" hint="Identify the advertiser, site, publication, etc. that is sending traffic to your property, for example: google, newsletter4, billboard."></v-text-field>
                              </v-col>
                              <v-col cols="12" sm="6" md="4">
                                <v-text-field :rules="[
                                      v => (v+'').length<=180 || 'UTM campaign medium may contain at most 180 characters'
                                    ]" validate-on-blur v-model="form.data.utm.utm_medium" label="UTM campaign medium" hint="The advertising or marketing medium, for example: cpc, banner, email newsletter."></v-text-field>
                              </v-col>
                              <v-col cols="12" sm="6" md="4">
                                <v-text-field :rules="[
                                      v => (v+'').length<=180 || 'UTM campaign name may contain at most 180 characters'
                                    ]" validate-on-blur v-model="form.data.utm.utm_campaign" label="UTM campaign name" hint="The individual campaign name, slogan, promo code, etc. for a product."></v-text-field>
                              </v-col>
                              <v-col cols="12" sm="6" md="4">
                                <v-text-field :rules="[
                                      v => (v+'').length<=180 || 'UTM campaign term may contain at most 180 characters'
                                    ]" validate-on-blur v-model="form.data.utm.utm_term" label="UTM campaign term" hint="Identify paid search keywords."></v-text-field>
                              </v-col>
                              <v-col cols="12" sm="6" md="4">
                                <v-text-field :rules="[
                                      v => (v+'').length<=180 || 'UTM campaign content may contain at most 180 characters'
                                    ]" validate-on-blur v-model="form.data.utm.utm_content" label="UTM campaign content" hint="Used to differentiate similar content, or links within the same ad."></v-text-field>
                              </v-col>
                            </v-row>
                          </v-card-text>
                        </v-expand-transition>
                      </v-card>
                    </v-col>
                    <!-- advanced settings -->
                    <v-col cols="12">
                      <v-card flat :outlined="form.show_advanced">
                        <v-card-text class="pa-0">
                          <v-btn text @click="form.show_advanced = !form.show_advanced">
                            <span>Advanced Settings</span>
                            <v-icon :class="{'icon-rotate':form.show_advanced}">mdi-chevron-down</v-icon>
                          </v-btn>
                        </v-card-text>
                        <v-expand-transition>
                          <v-card-text class="py-0" v-if="form.show_advanced">
                            <v-row dense>
                              <v-col cols="12" md="6">
                                <v-combobox label="Facebook Pixel IDs" v-model="form.data.pixel_ids" hide-details small-chips multiple deletable-chips></v-combobox>
                              </v-col>
                              <v-col cols="12" md="6">
                                <v-combobox label="Google Analytics IDs" v-model="form.data.ga_ids" hint="UA-XXXXX-Y" small-chips multiple deletable-chips></v-combobox>
                              </v-col>
                            </v-row>
                          </v-card-text>
                        </v-expand-transition>
                      </v-card>
                    </v-col>
                  </v-row>
                </v-form>
              </v-card-text>
              <v-divider></v-divider>
              <v-card-actions class="px-3">
                <v-row dense>
                  <v-spacer></v-spacer>
                  <v-col cols="auto">
                    <v-btn color="primary" @click="submit" :loading="form.loading">
                      <span>Submit</span>
                    </v-btn>
                  </v-col>
                </v-row>
              </v-card-actions>
            </v-card>
          </v-dialog>
          <v-dialog v-model="qrcode.shown" scrollable content-class="auto-width">
            <v-card>
              <v-card-text class="pa-0 text-center">
                <div v-if="_get(qrcode,'icon','')!=''"><v-switch class="mx-3 my-0 font-weight-bold" color="primary" label="Show Icon" v-model="qrcode.with_icon" hide-details></v-switch></div>
                <v-row no-gutters>
                  <v-col cols="12" v-if="qrcode.with_icon">
                    <img style="object-fit:contain; height: 80vh;" :src="qrcode.img+'&center_image='+qrcode.icon" :alt="qrcode.url">
                  </v-col>
                  <v-col cols="12" v-else>
                    <img style="object-fit:contain; height: 80vh;" :src="qrcode.img" :alt="qrcode.url">
                  </v-col>
                </v-row>
              </v-card-text>
              <!-- <img style="object-fit:contain; height: 80vh;" :src="qrcode.img" alt="qrcode.url"> -->
            </v-card>
          </v-dialog>
          <v-row class="ma-0" align="center" justify="center">
            <v-col cols="12">
              <h2 class="text-center white--text display-1 my-2">1Redirection Management</h2>
              <v-card>
                <v-card-title>
                  <v-row no-gutters align="center">
                    <v-col>
                      <span class="align-middle">Routing Table</span>
                      <v-btn icon color="primary" small @click="get">
                        <v-icon small>mdi-refresh</v-icon>
                      </v-btn>
                    </v-col>
                    <v-col cols="auto">
                      <v-btn icon color="primary" @click="addItem">
                        <v-icon>mdi-link-plus</v-icon>
                      </v-btn>
                    </v-col>
                  </v-row>
                </v-card-title>
                <v-card-text>
                  <v-card outlined>
                    <v-card-text class="py-2">
                      <v-text-field flat solo dense clearable prepend-icon="mdi-table-search" label="Search..." v-model="table.search" ref="search" type="search" hide-details>
                        <!-- append filters -->
                        <template v-slot:append>
                          <v-menu v-model="table.filtering" :close-on-content-click="false" offset-y transition="slide-y-transition">
                            <template v-slot:activator="{on}">
                              <v-btn v-on="on" text class="mr-n3 px-2" :icon="filters_count()<=0" :color="(filters_count()>0)?'primary':''">
                                <v-icon small>mdi-filter-variant</v-icon>
                                <span class="ml-1" v-if="filters_count()>0">{{filters_count()}} Filters</span>
                              </v-btn>
                            </template>
                            <v-card min-width="200px" max-width="400px">
                              <v-card-text class="py-2 px-3">
                                <v-row dense>
                                  <v-col cols="12">
                                    <div class="subtitle-2 pt-2 font-weight-bold">Domain filter</div>
                                    <v-select dense :items="domains" v-model="table.filters.domain" label="domain" small-chips single-line deletable-chips hide-details class="hide-input" clearable multiple ref="multiple_select" :menu-props="{ 
                                          bottom: true, 
                                          offsetY: true,
                                        }">
                                      <template v-slot:append-item>
                                        <v-row no-gutters style="background:inherit; margin-bottom:-8px; position:sticky; bottom:0;">
                                          <v-col cols="12">
                                            <v-divider></v-divider>
                                          </v-col>
                                          <v-col cols="12" class="pa-2">
                                            <v-btn block depressed outlined small color="primary" @click="$refs.multiple_select.blur()">Done</v-btn>
                                          </v-col>
                                        </v-row>
                                      </template>
                                      <!-- <template v-slot:item="{item}">
                                          <v-chip
                                            small
                                            :color="item.color"
                                            class="font-weight-bold px-2"
                                          >
                                            {{item.text}}
                                          </v-chip>
                                        </template>
                                        <template v-slot:selection="{item, parent}">
                                          <v-chip
                                            small
                                            :color="item.color"
                                            class="font-weight-bold px-2"
                                          >
                                            {{item.text}}
                                          </v-chip>
                                        </template> -->
                                    </v-select>
                                  </v-col>
                                </v-row>
                              </v-card-text>
                            </v-card>
                          </v-menu>
                        </template>
                      </v-text-field>
                    </v-card-text>
                    <v-divider></v-divider>
                    <v-data-table :key="table.key" :headers="table.headers" :items="filteredTable()" :loading="table.loading" :footer-props="{
                          'items-per-page-options': [10,20,50,100],
                        }" :options.sync="table.options" :hide-default-header="$vuetify.breakpoint.xsOnly">
                      <template v-slot:item.is_active="{ item }">
                        <div class="ml-n2 mr-n3">
                          <v-menu :close-on-content-click="false" offset-x transition="slide-y-transition">
                            <template v-slot:activator="{on}">
                              <v-btn x-small icon v-on="on" @click="">
                                <v-chip x-small class="px-1" style="height:8px;" :color="item.is_active?'success':'grey lighten-2'" @click=""></v-chip>
                              </v-btn>
                            </template>
                            <v-list dense nav>
                              <v-list-item color="primary" :input-value="item.is_active" style="min-height:32px" @click="changeStatus(item, true)">
                                <v-chip x-small class="px-1 mr-2" style="height:8px;" color="success"></v-chip>
                                <v-list-item-title :class="{'font-weight-bold':item.is_active, 'grey--text': !item.is_active}">Active</v-list-item-title>
                              </v-list-item>
                              <v-list-item color="primary" :input-value="!item.is_active" style="min-height:32px" @click="changeStatus(item, false)">
                                <v-chip x-small class="px-1 mr-2" style="height:8px;" color="grey lighten-2"></v-chip>
                                <v-list-item-title :class="{'font-weight-bold':!item.is_active, 'grey--text': item.is_active}" color="grey lighten-2">Inactive</v-list-item-title>
                              </v-list-item>
                            </v-list>
                          </v-menu>
                        </div>
                      </template>
                      <template v-slot:header.name="{ item }">
                        <div class="ml-n3">Route Name</div>
                      </template>
                      <template v-slot:item.name="{ item }">
                        <div class="ml-n3">
                          <span class="text-no-wrap align-middle">{{item.name}}</span>
                          <div>
                            <v-chip x-small label class="px-1 mr-1" :dark="getColorLuminance(generateColorRGB(i))<128" :color="generateColorRGB(i)" v-for="(i,k) in item.tags.slice(0,2)" :key="k">{{i}}</v-chip>
                            <v-chip x-small label class="px-1" v-if="item.tags.length>2">+{{item.tags.length-2}} more</v-chip>
                          </div>
                        </div>
                      </template>
                      <template v-slot:item.source_url="{ item }">
                        <div>
                          <v-avatar size="14" tile v-if="item.meta.image">
                            <img :src="item.meta.image" :alt="item.name + 'icon'">
                          </v-avatar>
                          <v-avatar size="14" tile v-else>
                            <img :src="'https://www.google.com/s2/favicons?domain='+item.source_url" :alt="item.name + 'icon'">
                          </v-avatar>
                          <span class="align-middle">{{item.source_url}}</span>
                          <v-tooltip top nudge-bottom="5px">
                            <template v-slot:activator="{ on }">
                              <v-btn v-on="on" depressed icon color="secondary" small @click="copyText(item.source_url)">
                                <v-icon size="18">mdi-content-copy</v-icon>
                              </v-btn>
                            </template>
                            <span>Copy</span>
                          </v-tooltip>
                        </div>
                      </template>
                      <template v-slot:item.destination_url="{ item }">
                        <div>
                          <v-avatar size="14" tile>
                            <img :src="'https://www.google.com/s2/favicons?domain='+item.destination_url" alt="icon">
                          </v-avatar>
                          <span class="align-middle">{{decodeURIComponent(item.destination_url)}}</span>
                          <v-btn small icon :href="item.destination_url" color="primary" target="_blank">
                            <v-icon size="18">mdi-earth-arrow-right</v-icon>
                          </v-btn>
                        </div>
                      </template>
                      <template v-slot:item.type="{ item }">
                        <div>
                          <v-chip x-small class="px-2" :dark="getColorLuminance(generateColorRGB(item.type))<128" :color="generateColorRGB(item.type)">{{item.type}}</v-chip>
                        </div>
                      </template>
                      <template v-slot:item.created_at="{ item }">
                        <div>
                          <span>{{getISODateString(item.created_at)}}</span>
                        </div>
                      </template>
                      <template v-slot:item.logs_count="{ item }">
                        <div>
                          <span>{{(item.logs_count||0)}}</span>
                        </div>
                      </template>
                      <template v-slot:item.action="{ item }">
                        <div class="text-center text-no-wrap">
                          <v-tooltip top nudge-bottom="5px">
                            <template v-slot:activator="{ on }">
                              <v-btn v-on="on" depressed icon color="primary" small @click="viewItem(item)">
                                <v-icon size="22">mdi-link</v-icon>
                              </v-btn>
                            </template>
                            <span>Edit</span>
                          </v-tooltip>
                          <v-tooltip top nudge-bottom="5px">
                            <template v-slot:activator="{ on }">
                              <v-btn v-on="on" depressed icon color="secondary" small @click="viewQRCode(item)">
                                <v-icon size="22">mdi-qrcode</v-icon>
                              </v-btn>
                            </template>
                            <span>QR code</span>
                          </v-tooltip>
                          <v-tooltip top nudge-bottom="5px">
                            <template v-slot:activator="{ on }">
                              <v-btn v-on="on" depressed icon color="grey" small :loading="item.deleting" @click="removeItem(item)">
                                <v-icon size="22">mdi-delete-outline</v-icon>
                              </v-btn>
                            </template>
                            <span>Delete</span>
                          </v-tooltip>
                        </div>
                      </template>
                    </v-data-table>
                  </v-card>
                </v-card-text>
              </v-card>
            </v-col>
          </v-row>
        </v-container>
        <!-- overlay -->
        <v-overlay v-model="invalid_t" :opacity="0.9" v-cloak>
          <v-card color="secondary" width="300px">
            <v-card-text>
              <v-text-field v-model="t" label="Password" autocomplete="token" placeholder=" " hide-details></v-text-field>
              <v-btn small class="mt-2" block color="primary" :href="'?t='+t">Enter</v-btn>
            </v-card-text>
          </v-card>
        </v-overlay>
      </v-content>
      <v-snackbar v-cloak bottom right class="d-flex" style="height: auto; user-select: none;" :style="snackbar.zindex?'z-index:'+snackbar.zindex:''" :timeout="snackbar.timeout" :color="snackbar.color" v-model="snackbar.show">
        <v-icon v-if="snackbar.icon" :dark="snackbar.dark" style="cursor:pointer" @click="snackbar.show = false">{{snackbar.icon}}</v-icon>
        <span class="font-weight-bold px-2">{{ snackbar.text }}</span>
        <template v-slot:action="{ attrs }">
          <v-btn v-bind="attrs" v-if="snackbar.timeout<=0" dark @click.native="snackbar.show = false" icon>
            <v-icon>close</v-icon>
          </v-btn>
        </template>
      </v-snackbar>
    </v-app>
  </div>
  </div>
  <!-- vue script -->
  <!-- <script src="https://cdn.jsdelivr.net/npm/vue@2.x/dist/vue.js"></script> -->
  <!-- <script src="https://cdn.jsdelivr.net/npm/vuetify@2.2.4/dist/vuetify.js"></script> -->
  <script src="https://cdnjs.cloudflare.com/ajax/libs/vuetify/2.2.4/vuetify.js"></script>
  <script>
    "use strict";
    (function() {
      var app = new Vue({
        el: '#app',
        vuetify: new Vuetify({
          theme: {
            themes: {
              light: {
                primary: '#4fa2c1',
                secondary: '#74ca9e',
              },
              dark: {
                primary: '#4fa2c1',
                secondary: '#74ca9e',
              },
            },
          }
        }),
        data: {
          table: {
            key: 1,
            options: {},
            headers: [{
                text: '',
                value: 'is_active',
                class: 'text-no-wrap',
                sortable: false,
                width: '30px'
              },
              {
                text: 'Route Name',
                value: 'name',
                class: 'text-no-wrap',
                sortable: false
              },
              {
                text: 'Route URL',
                value: 'source_url',
                class: 'text-no-wrap',
                sortable: false
              },
              {
                text: 'Destination',
                value: 'destination_url',
                class: 'text-no-wrap',
                sortable: false,
                width: "40%"
              },
              {
                text: 'Type',
                value: 'type',
                align: 'center',
                class: 'text-no-wrap'
              },
              {
                text: 'Created on',
                value: 'created_at',
                align: 'center',
                class: 'text-no-wrap'
              },
              {
                text: 'Viewed',
                value: 'logs_count',
                align: 'center',
                class: 'text-no-wrap'
              },
              {
                text: 'Action',
                value: 'action',
                align: 'center',
                class: 'text-no-wrap',
                sortable: false,
              }
            ],
            loading: false,
            items: [],
            search: '',
            filtering: false,
            filters: {
              domain: [],
            },
          },
          form: {
            loading: false,
            shown: false,
            show_advanced: false,
            valid: null,
            data: null,
          },
          route_item_temp: {
            is_enable_utm: false,
            type: "redirect",
            utm: {
              utm_source: "1ticks",
              utm_medium: "redirect",
              utm_campaign: "",
              utm_term: "",
              utm_content: "",
            },
            pixel_ids: [],
            ga_ids: [],
            is_active: true,
            is_canonical: true,
            meta: {},
          },
          domains: [],
          tags: [],
          snackbar: {
            show: false,
            timeout: -1,
            text: '',
            color: '',
          },
          qrcode: {
            shown: false,
            url: '',
            icon: '',
            img: '',
            with_icon: false,
          },
          uploading_image: false,
          uploader: null,
          gettingPreview: false,
          t: '',
          invalid_t: false,
        },
        computed: {},
        mounted() {
          this.get();
        },
        methods: {
          // validation
          is_valid_url(string) {
            try {
              new URL(string);
            } catch (err) {
              return false;
            }
            return true;
          },
          // utils
          clone(o) {
            return JSON.parse(JSON.stringify(o));
          },
          _get(object, keys, defaultVal) {
            if (object) {
              if (keys) {
                keys = Array.isArray(keys) ? keys : keys.split('.');
              } else {
                keys = [];
              }
              object = object[keys[0]];
              if (object && keys.length > 1) {
                return this._get(object, keys.slice(1), defaultVal);
              }
              return object === undefined ? defaultVal : object;
            } else {
              return defaultVal;
            }
          },
          copyText(text, toast = true) {
            let is_iOS = /iphone|ipad|ipod/i.test(navigator.userAgent.toLowerCase());
            let is_safari = /apple/i.test(navigator.vendor.toLowerCase());
            if (is_iOS || is_safari) {
              var textArea = document.createElement('textArea');
              textArea.value = text;
              document.body.appendChild(textArea);
              var range = document.createRange();
              range.selectNodeContents(textArea);
              var selection = window.getSelection();
              selection.removeAllRanges();
              selection.addRange(range);
              textArea.setSelectionRange(0, 999999);
              document.execCommand('copy');
              document.body.removeChild(textArea);
            } else {
              navigator.clipboard.writeText(text);
            }

            if (toast) {
              this.showToast({
                text: "Copy Successfully",
                zindex: 301
              }, "success");
            }
          },
          generateUUID() {
            let d = new Date().getTime();
            if (typeof performance !== 'undefined' && typeof performance.now === 'function') {
              d += performance.now(); // use high-precision timer if available
            }
            let newGuid = 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function(c) {
              let r = (d + Math.random() * 16) % 16 | 0;
              d = Math.floor(d / 16);
              return (c === 'x' ? r : (r & 0x3 | 0x8)).toString(16);
            });
            return newGuid;
          },
          generateColorRGB(seed = false) {
            seed = seed || new Date().toString();
            seed += "(" + seed.length.toString() + ")"
            var hash = 0;
            for (var i = 0; i < seed.length; i++) {
              hash = seed.charCodeAt(i) + ((hash << 5) - hash);
            }
            var c = (hash & 0x00FFFFFF)
              .toString(16)
              .toUpperCase();
            return "#" + ("00000".substring(0, 6 - c.length) + c);
          },
          getColorLuminance(rgb) {
            rgb = rgb.replace("#", "")
            var r = parseInt(rgb.slice(0, 2), 16)
            var g = parseInt(rgb.slice(2, 4), 16)
            var b = parseInt(rgb.slice(4, 6), 16)
            var luminance = 0.3 * r + 0.59 * g + 0.11 * b
            return luminance
          },
          showToast(args, style = false) {
            this.snackbar.show = false;
            switch (style) {
              case 'success':
                args = {
                  timeout: 3000,
                  color: 'success',
                  icon: 'mdi-check',
                  ...args,
                }
                break;
              case 'warning':
                args = {
                  timeout: 3000,
                  color: 'warning',
                  icon: 'mdi-close',
                  ...args,
                }
                break;
              case 'error':
                args = {
                  timeout: 3000,
                  color: 'error',
                  icon: 'mdi-close',
                  ...args,
                }
                break;
            }
            this.$nextTick().then(() => {
              let opts = {
                text: '',
                color: 'primary',
                timeout: -1,
                icon: false,
                dark: true,
                zindex: 201,
                ...args
              };
              this.snackbar = {
                ...opts,
                show: true
              };
            });
          },
          getISODateString(date) {
            // ISO 8601 TZ
            var iso_format_date;
            if (typeof date === "number") {
              iso_format_date = new Date(date);
            } else {
              iso_format_date = new Date((date && date.toString().split('+')[0]));
            }
            // locale datetime
            return new Date(iso_format_date).toLocaleDateString("fr-CA");
          },
          // image handling
          processFile(file, path) {
            if (path) {
              file = this._get(file, path)
            }
            this.uploading_image = true;
            if (file.size > 5 * 1024 * 1024) {
              swal("Upload Failure", "Image over 5MB file size. (" + file.name + ")", "error")
            } else {
              this.uploadImage(file)
            }
          },
          uploadImage(image) {
            let formData = new FormData();
            formData.append('files[]', image);
            let image_uuid = this.generateUUID();
            formData.append('uuid[]', image_uuid);
            formData.append('dir', '1r/meta_images/');
            formData.append('path', 'https://upload.1ticks.com' + '/');
            // formData.append('no_compress', true);
            $.ajax({
              url: "https://upload.1ticks.com/1r_upload.php",
              method: "post",
              data: formData,
              dataType: "json",
              processData: false,
              contentType: false,
            }).done((data) => {
              if (this._get(data, 'data.length', 0) > 0) {
                this.form.data.meta.image = this._get(data, 'data.0.url', '')
              } else if (data.data === "") {
                swal('Upload Failed', 'Image cannot compress', 'error')
              }
            }).fail(err => {
              this.handleError(err);
            }).always(() => {
              this.uploading_image = false;
            })
          },
          // page functions
          filters_count(filter_field) {
            if (filter_field) {
              return this._get(this.table.filters, filter_field + '.length', 0)
            } else {
              return Object.values(this.table.filters).filter(i => (i || []).length > 0).length
            }
          },
          filteredTable() {
            let items = this.table.items
            if (this.filters_count() > 0) {
              items = items.filter(i => {
                let visible = true
                Object.keys(this.table.filters).forEach((k) => {
                  if (!this.table.filters[k].includes(i[k])) {
                    visible = false
                  }
                })
                return visible
              })
            }
            if (this.table.search) {
              items = items.filter((i) => {
                if (JSON.stringify(i).toUpperCase().includes(this.table.search.toUpperCase())) {
                  return true
                }
                return false
              })
            }
            return items
          },
          updateTableKey() {
            return this.table.key++;
          },
          addItem() {
            this.form.data = this.clone(this.route_item_temp)
            this.form.shown = true
            this.$nextTick().then(() => {
              this.$refs.form && this.$refs.form.resetValidation()
            })
          },
          viewItem(item) {
            this.form.data = this.clone(item)
            this.form.shown = true
            if (this.form.data.type != 'redirect') {
              this.form.data.is_canonical = false
            }
            this.$nextTick().then(() => {
              this.$refs.form && this.$refs.form.resetValidation()
            })
          },
          viewQRCode(item) {
            this.qrcode.url = item.source_url
            this.qrcode.img = 'https://www.signhub.io/services/QRimg.php?data=' + item.source_url
            this.qrcode.icon = item.meta.image
            this.qrcode.with_icon = false
            this.qrcode.shown = true
          },
          removeItem(item) {
            swal({
              title: "Notice",
              icon: 'warning',
              text: 'Are you sure to remove "' + item.name + '"?',
              buttons: {
                cancel: true,
                confirm: true,
              }
            }).then((confirm) => {
              if (confirm) {
                item.deleting = true
                this.form.data = this.clone(item)
                this.delete()
              }
            })
          },
          changeStatus(item, is_active) {
            if (is_active != item.is_active) {
              this.form.data = this.clone(item)
              this.form.data.is_active = is_active
              this.update()
            }
          },
          submit() {
            this.form.loading = true
            let _this = this
            setTimeout(function() {
              if (_this.$refs.form.validate()) {
                if (_this.form.data.id > 0) {
                  _this.update()
                } else {
                  _this.create()
                }
              } else {
                _this.form.loading = false
                _this.showToast({
                  text: "Form is not valid.",
                  zindex: 301
                }, "warning");
              }
            }, 300);
          },
          remove(item) {
            let remove_index = this.table.items.map(i => i.id).indexOf(item.id)
              ~remove_index && this.table.items.splice(remove_index, 1)
          },
          store(item) {
            this.table.items.forEach((a, i) => {
              if (a.id == item.id) {
                this.table.items[i] = {
                  ...this.table.items[i],
                  ...item,
                };
              }
            })
          },
          // api
          handleError(err) {
            if (err.status === 0) {
              swal("沒有互聯網連接", "There is no internet connection", 'error');
            } else {
              console.error(err);
            }
          },
          create() {
            this.form.loading = true
            $.ajax({
              url: "https://r.1ticks.com/api/public/api/redirects",
              method: "post",
              dataType: "json",
              data: JSON.stringify(this.form.data),
              headers: {
                "authorization": "Bearer <?= $token; ?>",
                "content-type": "application/json"
              },
            }).done((res) => {
              this.table.items.unshift(res.data)
              this.updateTableKey()
              this.showToast({
                text: "Create Successfully",
                zindex: 301
              }, "success")
              this.form.shown = false
            }).fail(err => {
              this.handleError(err);
              if (err.status === 401) {
                this.invalid_t = true
              }
              if (err.responseJSON.error.code == 99999) {
                swal("URL exists", "This url (" + this.form.data.domain + this.form.data.path + ") has been used. Please change the domain or path.", 'warning');
              }
            }).always(() => {
              this.form.loading = false
            })
          },
          get() {
            this.table.loading = true;
            $.ajax({
              url: "https://r.1ticks.com/api/public/api/redirects?with_count[]=logs",
              method: "get",
              dataType: "json",
              headers: {
                "authorization": "Bearer <?= $token; ?>",
              },
            }).done((res) => {
              this.table.items = this.clone(res.data)
              this.domains = this.clone(res.domains)
              this.table.items.forEach((item) => {
                if (item.tag && !this.tags.includes(item.tag)) {
                  this.tags.push(item.tag)
                }
              })
            }).fail(err => {
              this.handleError(err);
              if (err.status === 401) {
                this.invalid_t = true
              }
            }).always(() => {
              this.table.loading = false;
            })
          },
          update() {
            this.form.loading = true
            $.ajax({
              url: "https://r.1ticks.com/api/public/api/redirects/" + this.form.data.id,
              method: "put",
              dataType: "json",
              data: JSON.stringify(this.form.data),
              headers: {
                "authorization": "Bearer <?= $token; ?>",
                "content-type": "application/json"
              },
            }).done((res) => {
              this.store(res.data)
              this.updateTableKey()
              this.showToast({
                text: "Update Successfully",
                zindex: 301
              }, "success");
              this.form.shown = false
            }).fail(err => {
              this.handleError(err);
              if (err.status === 401) {
                this.invalid_t = true
              }
              if (err.responseJSON.error.code == 99999) {
                swal("URL exists", "This url (" + this.form.data.domain + this.form.data.path + ") has been used. Please change the domain or path.", 'warning');
              }
            }).always(() => {
              this.form.loading = false
            })
          },
          delete() {
            this.form.loading = true
            $.ajax({
              url: "https://r.1ticks.com/api/public/api/redirects/" + this.form.data.id + "/delete",
              method: "post",
              dataType: "json",
              data: JSON.stringify(this.form.data),
              headers: {
                "authorization": "Bearer <?= $token; ?>",
                "content-type": "application/json"
              },
            }).done((res) => {
              this.remove(this.form.data)
              this.updateTableKey()
              this.showToast({
                text: "Remove Successfully",
                zindex: 301
              }, "success");
            }).fail(err => {
              this.handleError(err);
              if (err.status === 401) {
                this.invalid_t = true
              }
            }).always(() => {
              this.form.loading = false
            })
          },
          getPreview() {
            this.gettingPreview = true
            $.ajax({
              url: "getPage.php",
              method: "post",
              dataType: "json",
              data: this.form.data,
              headers: {
                "authorization": "Bearer <?= $token; ?>",
              },
            }).done((res) => {
              var head = "<div>" + res['head'] + "</div>"
              var head_title = this._get($(head).find("title"), '0.text')
              var head_desc = this._get($(head).find("meta[name='description']"), '0.content')
              var head_img = this._get($(head).find("meta[property*=image]"), '0.content') || this._get($(head).find("link[rel*=icon]"), '0.href')

              this.form.data.meta.title = head_title || this.form.data.meta.title
              this.form.data.meta.description = head_desc || this.form.data.meta.description
              this.form.data.meta.image = head_img || this.form.data.meta.image
            }).fail(err => {
              this.handleError(err);
              if (err.status === 401) {
                this.invalid_t = true
              }
              if (err.status === 403) {
                swal("Error", "Incorrect access token or session expired.", 'error');
              } else {
                swal("Error", "The destination preview contains invalid characters.", 'error');
              }
            }).always(() => {
              this.gettingPreview = false
            })
          }
          // preview
          // isSameProtocol (item) {
          //   return location.protocol == new URL(item.destination_url).protocol
          // },
        }
      });
    })();
  </script>
</body>

</html>